from typing import Set

from slashdb.dbproxies.sqlalchemy_sdb.model import SQLAlchemyModel
from slashdb.dbproxies.sqlalchemy_sdb.model import SQLAlchemyModuleMaker
from slashdb.dbproxies.sqlalchemy_sdb import SQLAlchemyDBConfig

from slashdb.dbproxies.sqlite_sdb.dataproxy import SqliteDataProxy, DB_TYPES


class SQLiteModel(SQLAlchemyModel):
    db_types = DB_TYPES


class SQLiteModuleMaker(SQLAlchemyModuleMaker):
    db_types = DB_TYPES


class SQLiteDBConfig(SQLAlchemyDBConfig):
    db_types = DB_TYPES

    @property
    def supported_placeholders(self) -> Set[str]:
        if self.db_type == 'sqlite':
            return {'db_name'}
        elif self.db_type == 'sqlcipher':
            return {'db_name', 'dbpass'}


ModuleMaker = SQLiteModuleMaker
Model = SQLiteModel
DataProxy = SqliteDataProxy
DBConfig = SQLiteDBConfig
